## indigo 1.4.3

=== api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(Indigo)

include(indigo-version.cmake)
include(DefineTest)

MESSAGE(STATUS "Indigo version is ${INDIGO_VERSION}")
SET(INDIGO_VERSION "${INDIGO_VERSION}" PARENT_SCOPE) # promote Indigo version
configure_file(${Indigo_SOURCE_DIR}/src/indigo_version.h.in ${Indigo_SOURCE_DIR}/src/indigo_version.h)

file (GLOB Indigo_src src/*.c*)
file (GLOB Indigo_headers *.h* src/*.h*)

# Get defined variable with the headers for TinyXML
get_directory_property(TinyXML_HEADERS_DIR DIRECTORY ../third_party/tinyxml DEFINITION TinyXML_HEADERS_DIR)

include_directories(${Indigo_SOURCE_DIR} ${Common_SOURCE_DIR} ${Common_SOURCE_DIR}/.. ${TinyXML_HEADERS_DIR} ${InChI_SOURCE_DIR}/inchi_dll)

add_library(indigoObj OBJECT ${Indigo_src} ${Indigo_headers})
set_target_properties(indigoObj PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")

#Indigo static
if (WITH_STATIC)
    add_library(indigo STATIC $<TARGET_OBJECTS:indigoObj> $<TARGET_OBJECTS:graph> $<TARGET_OBJECTS:layout> $<TARGET_OBJECTS:molecule> $<TARGET_OBJECTS:common> $<TARGET_OBJECTS:reaction>)
    SET_TARGET_PROPERTIES(indigo PROPERTIES OUTPUT_NAME "indigo-static")
    target_link_libraries(indigo tinyxml z inchi)
    set_property(TARGET indigo PROPERTY FOLDER "indigo")
    # No exports in case of static library: define empty EXPORT_SYMBOL definition
    set_target_properties(indigo PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS} -DEXPORT_SYMBOL= ")
    pack_static(indigo)
endif()


# Indigo shared
add_library(indigo-shared SHARED $<TARGET_OBJECTS:indigoObj> $<TARGET_OBJECTS:graph> $<TARGET_OBJECTS:layout> $<TARGET_OBJECTS:molecule> $<TARGET_OBJECTS:common> $<TARGET_OBJECTS:reaction> ${Common_SOURCE_DIR}/hacks/memcpy.c)

# Copy shared library to indigo/api/libs/shared/ folder, that is used by python tests and wrappers generation
add_custom_command(
        TARGET indigo-shared
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_SOURCE_DIR}/libs/shared/${SYSTEM_NAME}/${SUBSYSTEM_NAME}
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:indigo-shared> ${CMAKE_CURRENT_SOURCE_DIR}/libs/shared/${SYSTEM_NAME}/${SUBSYSTEM_NAME}/)

SET_TARGET_PROPERTIES(indigo-shared PROPERTIES OUTPUT_NAME "indigo")
set_target_properties(indigo-shared PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")
if (APPLE)
    set_target_properties(indigo-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -undefined dynamic_lookup")
endif()
if (UNIX AND NOT APPLE)
    if(${SUBSYSTEM_NAME} MATCHES "x64")
        set_target_properties(indigo-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -Wl,--wrap=memcpy -Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/indigo.so.map -Wl,--dynamic-list-cpp-typeinfo")
    endif()
    target_link_libraries(indigo-shared -lpthread -lrt)
endif()
if (MSVC OR MINGW)
    set_target_properties(indigo-shared PROPERTIES PREFIX "")
endif()
target_link_libraries(indigo-shared z tinyxml inchi)
if(UNIX AND NOT APPLE)
    set_property(TARGET indigo-shared PROPERTY LINK_INTERFACE_LIBRARIES "-lpthread;-lrt;z;tinyxml;inchi")
else()
    set_property(TARGET indigo-shared PROPERTY LINK_INTERFACE_LIBRARIES "z;tinyxml;inchi")
endif()
set_property(TARGET indigo-shared PROPERTY FOLDER "indigo")
if (NOT PACK_INDIGO_NOT)
    pack_shared(indigo-shared)
endif()
if (NOT DEFINED ENV{DISABLE_INDIGO_TESTS})
DEFINE_TEST(indigo-c-test-shared "tests/c/indigo-test.c" indigo-shared)
endif()

add_executable(dlopen-test ${Indigo_SOURCE_DIR}/tests/c/dlopen-test.c)
if (UNIX AND NOT APPLE)
    set_target_properties(dlopen-test PROPERTIES LINK_FLAGS "-rdynamic -ldl -pthread")
    if (NOT APPLE AND ${SUBSYSTEM_NAME} MATCHES "x64")
        set_target_properties(dlopen-test PROPERTIES LINK_FLAGS "-rdynamic -ldl -pthread -Wl,--wrap=memcpy")
    endif()
    TARGET_LINK_LIBRARIES(dlopen-test "-rdynamic -ldl -lpthread")
endif()
set_property(TARGET dlopen-test PROPERTY FOLDER "tests")

=== common/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(Common C CXX)
# Collect file list for BaseC
file (GLOB BaseC_src base_c/*.c*)
if (MSVC OR MINGW)
    file (GLOB BaseC_src_excl base_c/*_posix.c*)
else()
    file (GLOB BaseC_src_excl base_c/*_win.c* base_c/*_win32.c*)
endif()
list (REMOVE_ITEM BaseC_src ${BaseC_src_excl})
file (GLOB BaseC_headers base_c/*.h*)

# Collect file list for BaseCpp
file (GLOB BaseCpp_src base_cpp/*.c*)
if (MSVC OR MINGW)
    file (GLOB BaseCpp_src_excl base_cpp/*_posix.c*)
else()
    file (GLOB BaseCpp_src_excl base_cpp/*_win.c* base_cpp/*_win32.c*)
endif()
list (REMOVE_ITEM BaseCpp_src ${BaseCpp_src_excl})
file (GLOB BaseCpp_headers base_cpp/*.h*)

# comment to regenerate files

# Collect file list for LZW
file (GLOB LZW_src lzw/*.c*)
file (GLOB LZW_headers lzw/*.h*)

# Collect file list for Math
file (GLOB Math_src math/*.c*)
file (GLOB Math_headers math/*.h*)

source_group("BaseC" FILES ${BaseC_src} ${BaseC_headers})
source_group("BaseCpp" FILES ${BaseCpp_src} ${BaseCpp_headers})
source_group("LZW" FILES ${LZW_src} ${LZW_headers})
source_group("Math" FILES ${Math_src} ${Math_headers})

include_directories(${Common_SOURCE_DIR})
include_directories(${ZLib_HEADERS_DIR})

add_library(common OBJECT ${BaseC_src} ${BaseC_headers} ${BaseCpp_src} ${BaseCpp_headers} ${LZW_src} ${LZW_headers} ${Math_src} ${Math_headers})


if(UNIX OR APPLE)
    set(COMPILE_FLAGS "${COMPILE_FLAGS} -Wall")
endif()

set_target_properties(common PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")

=== graph/CMakeLists.txt ===
PROJECT(Graph)

file (GLOB Graph_src src/*.c src/*.cpp)
file (GLOB Graph_headers *.h *.hpp src/*.h src/*.hpp src/*.inc)

include_directories(${Common_SOURCE_DIR} ${Graph_SOURCE_DIR}/..)

add_library(graph OBJECT ${Graph_src} ${Graph_headers})

if(UNIX OR APPLE)
    set(COMPILE_FLAGS "${COMPILE_FLAGS} -Wall")
endif()

set_target_properties(graph PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")

=== molecule/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

PROJECT(Molecule)

file (GLOB Molecule_src src/*.c src/*.cpp)
file (GLOB Molecule_headers *.h *.hpp src/*.h src/*.hpp)

# Collect file list for GZip
file (GLOB GZip_src ${Common_SOURCE_DIR}/gzip/*.c*)
file (GLOB GZip_headers ${Common_SOURCE_DIR}/gzip/*.h*)
source_group("GZip" FILES ${GZip_src} ${GZip_headers})

include_directories(${Common_SOURCE_DIR} ${Molecule_SOURCE_DIR}/.. ${ZLib_HEADERS_DIR} ${TinyXML_HEADERS_DIR})

add_library(molecule OBJECT ${Molecule_src} ${Molecule_headers} ${GZip_src} ${GZip_headers})


if(UNIX OR APPLE)
    set(COMPILE_FLAGS "${COMPILE_FLAGS} -Wall -Wno-unused-but-set-variable -Wno-strict-aliasing -Wno-strict-overflow")
endif()

set_target_properties(molecule PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS} -DTARGET_API_LIB")

include_directories (../third_party/inchi/INCHI_BASE/src)
# include_directories (../third_party/inchi/INCHI_API/libinchi/src)

=== api/r/DESCRIPTION ===
Package: rindigo
Version: 0.2
Date: 2014-11-10
Title: R Package for Indigo Toolkit
Authors@R: c(person(given = "Mikhail", family = "Kviatkovskii", role = c("cre"), 
        email = "Mikhail_Kviatkovskii@epam.com"))
Description: R Package for Indigo Toolkit
NeedsCompile: Yes
License: Apache License 2.0
URL: http://lifescience.opensource.epam.com/indigo/api
Author: Mikhail Kviatkovskii [cre]
Maintainer: Mikhail Kviatkovskii <Mikhail_Kviatkovskii@epam.com>
Packaged: 2014-12-18 15:26:37 UTC; mk

=== bingo/bingo-core-c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoCoreC)

file(GLOB BingoCoreC_src src/*.cpp)
file(GLOB BingoCoreC_headers src/*.h)

set(BingoCoreC_HEADERS_DIR ${BingoCoreC_SOURCE_DIR}/src CACHE INTERNAL "include directories" FORCE)

include(ConfigureCommon)

include_directories(../src ../src/core ${Common_SOURCE_DIR} ${Common_SOURCE_DIR}/.. ${ZLib_HEADERS_DIR} ${BingoCore_HEADERS_DIR}
	${Common_SOURCE_DIR}/../api/plugins/inchi/src ${InChI_SOURCE_DIR}/INCHI_BASE/src)

add_library(bingo-core-c STATIC ${BingoCoreC_src} ${BingoCoreC_headers})
target_link_libraries(bingo-core-c bingo-core inchi)
if(APPLE)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -lc++")
endif()
set_target_properties(bingo-core-c PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")
set_property(TARGET bingo-core-c PROPERTY FOLDER "bingo-core-c")
set_property(TARGET bingo-core-c PROPERTY OUTPUT_NAME "bingo-core-c-static")


if(BINGO_SQLSERVER)
    add_library(bingo-core-c-shared SHARED ${BingoCoreC_src} ${BingoCoreC_headers} ${Common_SOURCE_DIR}/hacks/memcpy.c $<TARGET_OBJECTS:graph> $<TARGET_OBJECTS:layout> $<TARGET_OBJECTS:molecule> $<TARGET_OBJECTS:common> $<TARGET_OBJECTS:reaction>)
	target_link_libraries(bingo-core-c-shared bingo-core inchi tinyxml z)
	if (APPLE)
		set_target_properties(bingo-core-c-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -lc++")
	endif()
	if (UNIX AND NOT APPLE)
		if(${SUBSYSTEM_NAME} MATCHES "x64")
			set_target_properties(bingo-core-c-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -Wl,--wrap=memcpy")
		endif()
	endif()
	set_target_properties(bingo-core-c-shared PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")
	set_property(TARGET bingo-core-c-shared PROPERTY FOLDER "bingo-core-c-shared")
	set_property(TARGET bingo-core-c-shared PROPERTY OUTPUT_NAME "bingo-core-c")
endif()

=== bingo/bingo-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoCore)

SET(BingoCore_HEADERS_DIR ${BingoCore_SOURCE_DIR}/src CACHE INTERNAL "include directories" FORCE)
CMAKE_POLICY(SET CMP0011 NEW)
INCLUDE(${Bingo_SOURCE_DIR}/bingo-version.cmake)                                            
MESSAGE(STATUS "BingoCore version is ${BINGO_VERSION}")
configure_file(${BingoCore_HEADERS_DIR}/core/bingo_version.h.in ${BingoCore_HEADERS_DIR}/core/bingo_version.h)

file(GLOB BingoCore_src src/core/*.cpp)
file(GLOB BingoCore_headers ${BingoCore_HEADERS_DIR}/core/*.h)

include(SetBuildParameters)
include_directories(src ${Common_SOURCE_DIR} ${Common_SOURCE_DIR}/..)
add_library(bingo-core STATIC ${BingoCore_src} ${BingoCore_headers})
set_target_properties(bingo-core PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")

set_property(TARGET bingo-core PROPERTY FOLDER "bingo-core")

=== bingo/oracle/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoOracle)

include(../bingo-version.cmake)
include(ConfigureCommon)

message(STATUS "BingoOracle version is ${BINGO_VERSION_EXT}")

file(GLOB Bingo_src src/oracle/*.cpp)
file(GLOB Bingo_headers src/oracle/*.h)

include_directories(src ${Common_SOURCE_DIR} ${Common_SOURCE_DIR}/.. ${OCI_INCLUDE_DIRS} ${ZLib_HEADERS_DIR} ${BingoCore_HEADERS_DIR}
	${InChI_SOURCE_DIR}/INCHI_BASE/src  ${InChI_SOURCE_DIR}/INCHI_BASE/src)

add_library(bingo-oracle-shared SHARED ${Bingo_src} ${Bingo_headers} ${Common_SOURCE_DIR}/hacks/memcpy.c $<TARGET_OBJECTS:graph> $<TARGET_OBJECTS:layout> $<TARGET_OBJECTS:molecule> $<TARGET_OBJECTS:common> $<TARGET_OBJECTS:reaction>)

if (UNIX AND NOT APPLE)
	if(${SUBSYSTEM_NAME} MATCHES "x64")
		set_target_properties(bingo-oracle-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -Wl,--wrap=memcpy")
	endif()
endif()

set_target_properties(bingo-oracle-shared PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")

target_link_libraries(bingo-oracle-shared bingo-core common-oracle inchi tinyxml z)
if (MSVC)
	target_link_libraries(bingo-oracle-shared odbc32 odbccp32 ${OCI_LIBRARY})
elseif(APPLE)
	target_link_libraries(bingo-oracle-shared ${OCI_LIBRARY})
endif()
set_property(TARGET bingo-oracle-shared PROPERTY LINK_INTERFACE_LIBRARIES "")

SET_TARGET_PROPERTIES(bingo-oracle-shared PROPERTIES OUTPUT_NAME "bingo-oracle")

set_property(TARGET bingo-oracle-shared PROPERTY FOLDER "bingo-oracle")

pack_bingo(bingo-oracle-shared)

=== bingo/postgres/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoPostgres C CXX)

include(../bingo-version.cmake)
include(ConfigureCommon)

message(STATUS "BingoPostgres version is ${BINGO_VERSION_EXT}")

find_package(POSTGRES)
if (NOT POSTGRES_FOUND)
	message(FATAL_ERROR "Postgres not found!")
endif()
message(STATUS "Postgres found at ${POSTGRES_INCLUDE_DIRS}")

file(GLOB PG_AM_src src/pg_am/*.cpp src/pg_am/*.c)
file(GLOB PG_AM_headers src/pg_am/*.h)
file(GLOB PG_COMMON_src src/pg_common/*.cpp src/pg_common/*.c)
file(GLOB PG_COMMON_headers src/pg_common/*.h)
file(GLOB PG_CORE_src src/pg_core/*.cpp src/pg_core/*.c)
file(GLOB PG_CORE_headers src/pg_core/*.h)

include_directories(src ${Common_SOURCE_DIR} ${Common_SOURCE_DIR}/.. ${ZLib_HEADERS_DIR}  ${BingoCoreC_HEADERS_DIR} ${BingoCore_HEADERS_DIR} ${POSTGRES_INCLUDE_DIRS} src/pg_common/ src/pg_am/ src/pg_core/)
if (MSVC)
	include_directories(${POSTGRES_INCLUDE_DIRS}/port/win32_msvc ${POSTGRES_INCLUDE_DIRS}/port/win32 ${POSTGRES_INCLUDE_DIRS}/..)
endif()

if (NOT MSVC)
	add_library(bingo-postgres-shared SHARED ${PG_AM_src} ${PG_AM_headers} ${PG_COMMON_src} ${PG_COMMON_headers} ${PG_CORE_src} ${PG_CORE_headers} ${Common_SOURCE_DIR}/hacks/memcpy.c $<TARGET_OBJECTS:graph> $<TARGET_OBJECTS:layout> $<TARGET_OBJECTS:molecule> $<TARGET_OBJECTS:common> $<TARGET_OBJECTS:reaction>)
else()
	add_library(bingo-postgres-shared SHARED ${PG_AM_src} ${PG_AM_headers} ${PG_COMMON_src} ${PG_COMMON_headers} ${PG_CORE_src} ${PG_CORE_headers} ${POSTGRES_INCLUDE_DIRS}/port/win32.h $<TARGET_OBJECTS:graph> $<TARGET_OBJECTS:layout> $<TARGET_OBJECTS:molecule> $<TARGET_OBJECTS:common> $<TARGET_OBJECTS:reaction>)
endif()
SET_TARGET_PROPERTIES(bingo-postgres-shared PROPERTIES OUTPUT_NAME "bingo_postgres")
SET_TARGET_PROPERTIES(bingo-postgres-shared PROPERTIES PREFIX "")

set_target_properties(bingo-postgres-shared PROPERTIES COMPILE_FLAGS "${COMPILE_FLAGS}")
if (APPLE)
	set_target_properties(bingo-postgres-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -undefined suppress -flat_namespace")
elseif(UNIX)
	set_target_properties(bingo-postgres-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -pthread")
endif()

if (UNIX AND NOT APPLE)
	if(${SUBSYSTEM_NAME} MATCHES "x64")
		set_target_properties(bingo-postgres-shared PROPERTIES LINK_FLAGS "${LINK_FLAGS} -pthread -Wl,--wrap=memcpy")
	endif()
endif()

target_link_libraries(bingo-postgres-shared bingo-core-c bingo-core z tinyxml)
if (MSVC)
	target_link_libraries(bingo-postgres-shared ${POSTGRES_LIBRARY})
endif()

set_property(TARGET bingo-postgres-shared PROPERTY LINK_INTERFACE_LIBRARIES "")
set_property(TARGET bingo-postgres-shared PROPERTY FOLDER "bingo-postgres")

pack_bingo(bingo-postgres-shared)

=== build_scripts/bingo-oracle/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoOracleSolution)

set(Bingo_SOURCE_DIR ../../bingo)

set(BINGO "YES")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/../../common/cmake/)

INCLUDE(ConfigureCommon)

if(MSVC)
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
	set(CMAKE_C_LINK_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_SHARED_LIBRARY_C_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_CXX_LINK_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
endif()

add_subdirectory(../../third_party/zlib-src "${CMAKE_CURRENT_BINARY_DIR}/zlib")
# Get defined variable with the headers
get_directory_property(ZLib_HEADERS_DIR DIRECTORY ../../third_party/zlib-src DEFINITION ZLib_HEADERS_DIR)

add_subdirectory(../../common "${CMAKE_CURRENT_BINARY_DIR}/common")

add_subdirectory(../../third_party/tinyxml "${CMAKE_CURRENT_BINARY_DIR}/tinyxml")
# Get defined variable with the headers
get_directory_property(TinyXML_HEADERS_DIR DIRECTORY ../../third_party/tinyxml DEFINITION TinyXML_HEADERS_DIR)

add_subdirectory(../../graph "${CMAKE_CURRENT_BINARY_DIR}/graph")
add_subdirectory(../../molecule "${CMAKE_CURRENT_BINARY_DIR}/molecule")
add_subdirectory(../../reaction "${CMAKE_CURRENT_BINARY_DIR}/reaction")

add_subdirectory(../../layout "${CMAKE_CURRENT_BINARY_DIR}/layout")

add_subdirectory(../../third_party/oci "${CMAKE_CURRENT_BINARY_DIR}/oci")
get_directory_property(OCI_INCLUDE_DIRS DIRECTORY ../../third_party/oci DEFINITION OCI_INCLUDE_DIRS)
get_directory_property(OCI_LIBRARY_DIRS DIRECTORY ../../third_party/oci DEFINITION OCI_LIBRARY_DIRS)
get_directory_property(OCI_LIBRARY DIRECTORY ../../third_party/oci DEFINITION OCI_LIBRARY)

add_subdirectory(../../bingo/bingo-core "${CMAKE_CURRENT_BINARY_DIR}/bingo-core")
add_subdirectory(../../common/oracle "${CMAKE_CURRENT_BINARY_DIR}/common-oracle")

add_subdirectory(../../third_party/inchi "${CMAKE_CURRENT_BINARY_DIR}/inchi")

add_subdirectory(../../bingo/oracle "${CMAKE_CURRENT_BINARY_DIR}/bingo-oracle")

SET(BINGO_VERSION "${BINGO_VERSION}")

SET(COMPONENTS shared)

# Uncomment it in CMake 2.8.8:  http://www.gccxml.org/Bug/view.php?id=12129
SET(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)

SET(CPACK_COMPONENTS_ALL ${COMPONENTS})
set(CPACK_ARCHIVE_COMPONENT_INSTALL 1)
SET(CPACK_GENERATOR "ZIP")
SET(CPACK_PACKAGE_FILE_NAME "bingo-oracle-${BINGO_VERSION}-${PACKAGE_SUFFIX}")
foreach(comp ${COMPONENTS})
	INSTALL(FILES ${Bingo_SOURCE_DIR}/LICENSE DESTINATION . COMPONENT ${comp})
	INSTALL(DIRECTORY ${BingoOracle_SOURCE_DIR}/sql/ DESTINATION sql COMPONENT ${comp})
	IF(${SYSTEM_NAME} MATCHES "Win")
		INSTALL(FILES ${BingoOracle_SOURCE_DIR}/setup/bingo-oracle-install.bat DESTINATION . COMPONENT ${comp})
	ELSE()
		INSTALL(FILES ${BingoOracle_SOURCE_DIR}/setup/bingo-oracle-install.sh DESTINATION . COMPONENT ${comp})
	ENDIF()
endforeach()

SET(CMAKE_INSTALL_PREFIX ${BingoOracle_SOURCE_DIR}/libs)

INCLUDE(CPack)

=== build_scripts/bingo-postgres/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoPostgresSolution C CXX)

set(BINGO "YES")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/../../common/cmake/)
set(Bingo_SOURCE_DIR ../../bingo/)

INCLUDE(ConfigureCommon)

if(MSVC)
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
	set(CMAKE_C_LINK_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_SHARED_LIBRARY_C_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_CXX_LINK_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
endif()

add_subdirectory(../../third_party/zlib-src "${CMAKE_CURRENT_BINARY_DIR}/zlib")
# Get defined variable with the headers
get_directory_property(ZLib_HEADERS_DIR DIRECTORY ../../third_party/zlib-src DEFINITION ZLib_HEADERS_DIR)

add_subdirectory(../../common "${CMAKE_CURRENT_BINARY_DIR}/common")

add_subdirectory(../../third_party/tinyxml "${CMAKE_CURRENT_BINARY_DIR}/tinyxml")
# Get defined variable with the headers
get_directory_property(TinyXML_HEADERS_DIR DIRECTORY ../../third_party/tinyxml DEFINITION TinyXML_HEADERS_DIR)

add_subdirectory(../../graph "${CMAKE_CURRENT_BINARY_DIR}/graph")
add_subdirectory(../../molecule "${CMAKE_CURRENT_BINARY_DIR}/molecule")
add_subdirectory(../../reaction "${CMAKE_CURRENT_BINARY_DIR}/reaction")

add_subdirectory(../../layout "${CMAKE_CURRENT_BINARY_DIR}/layout")

add_subdirectory(../../bingo/bingo-core "${CMAKE_CURRENT_BINARY_DIR}/bingo-core")
add_subdirectory(../../third_party/inchi "${CMAKE_CURRENT_BINARY_DIR}/inchi")
add_subdirectory(../../bingo/bingo-core-c "${CMAKE_CURRENT_BINARY_DIR}/bingo-core-c")
add_subdirectory(../../bingo/postgres "${CMAKE_CURRENT_BINARY_DIR}/bingo-postgres")

SET(BINGO_VERSION "${BINGO_VERSION}")

SET(BINGO_PG_VERSION "$ENV{BINGO_PG_VERSION}" CACHE STRING "PostgreSQL version (9.0, 9.1, 9.2, 9.4, 9.5)")
SET(BINGO_PG_DIR "$ENV{BINGO_PG_DIR}" CACHE STRING "PostgreSQL folder")

SET(COMPONENTS shared)

# Uncomment it in CMake 2.8.8:  http://www.gccxml.org/Bug/view.php?id=12129
SET(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)

SET(CPACK_COMPONENTS_ALL ${COMPONENTS})
set(CPACK_ARCHIVE_COMPONENT_INSTALL 1)
SET(CPACK_GENERATOR "ZIP")
SET(CPACK_PACKAGE_FILE_NAME "bingo-postgres$ENV{BINGO_PG_VERSION}-${BINGO_VERSION}-${PACKAGE_SUFFIX}")
foreach(comp ${COMPONENTS})
	INSTALL(FILES ${Bingo_SOURCE_DIR}/LICENSE DESTINATION . COMPONENT ${comp})
	INSTALL(FILES ${BingoPostgres_SOURCE_DIR}/README.md DESTINATION . COMPONENT ${comp})
	INSTALL(DIRECTORY ${BingoPostgres_SOURCE_DIR}/sql/common/ DESTINATION sql COMPONENT ${comp})
	INSTALL(DIRECTORY ${BingoPostgres_SOURCE_DIR}/sql/$ENV{BINGO_PG_VERSION}/ DESTINATION sql COMPONENT ${comp})
	IF(${SYSTEM_NAME} MATCHES "Win")
		INSTALL(FILES ${BingoPostgres_SOURCE_DIR}/bingo-pg-install.bat DESTINATION . COMPONENT ${comp})
	ELSE()
		INSTALL(FILES ${BingoPostgres_SOURCE_DIR}/bingo-pg-install.sh DESTINATION . COMPONENT ${comp})
	ENDIF()
endforeach()

SET(CMAKE_INSTALL_PREFIX ${BingoPostgres_SOURCE_DIR}/libs)

INCLUDE(CPack)

=== build_scripts/bingo-sqlserver/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(BingoSqlServerSolution)

set(BINGO "YES")
set(BINGO_SQLSERVER "YES")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/../../common/cmake/)
set(Bingo_SOURCE_DIR ../../bingo/)
set(BingoSqlServer_SOURCE_DIR ../../bingo/sqlserver)

INCLUDE(ConfigureCommon)

if(MSVC)
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
	set(CMAKE_C_LINK_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_SHARED_LIBRARY_C_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_CXX_LINK_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
	set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "/NODEFAULTLIB:libc.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrtd.lib")
endif()

add_subdirectory(../../third_party/zlib-src "${CMAKE_CURRENT_BINARY_DIR}/zlib")
# Get defined variable with the headers
get_directory_property(ZLib_HEADERS_DIR DIRECTORY ../../third_party/zlib-src DEFINITION ZLib_HEADERS_DIR)

add_subdirectory(../../common "${CMAKE_CURRENT_BINARY_DIR}/common")

add_subdirectory(../../third_party/tinyxml "${CMAKE_CURRENT_BINARY_DIR}/tinyxml")
# Get defined variable with the headers
get_directory_property(TinyXML_HEADERS_DIR DIRECTORY ../../third_party/tinyxml DEFINITION TinyXML_HEADERS_DIR)

add_subdirectory(../../graph "${CMAKE_CURRENT_BINARY_DIR}/graph")
add_subdirectory(../../molecule "${CMAKE_CURRENT_BINARY_DIR}/molecule")
add_subdirectory(../../reaction "${CMAKE_CURRENT_BINARY_DIR}/reaction")

add_subdirectory(../../layout "${CMAKE_CURRENT_BINARY_DIR}/layout")
add_subdirectory(../../bingo/bingo-core "${CMAKE_CURRENT_BINARY_DIR}/bingo-core")
get_directory_property(BingoCore_HEADERS_DIR DIRECTORY ../../bingo/bingo-core DEFINITION BingoCore_HEADERS_DIR)

add_subdirectory(../../third_party/inchi "${CMAKE_CURRENT_BINARY_DIR}/inchi")

add_subdirectory(../../bingo/bingo-core-c "${CMAKE_CURRENT_BINARY_DIR}/bingo-core-c")
get_directory_property(BingoCoreC_HEADERS_DIR DIRECTORY ../../bingo/bingo-core-c DEFINITION BingoCoreC_HEADERS_DIR)

SET(BINGO_VERSION "${BINGO_VERSION}")

#ADD_CUSTOM_COMMAND(OUTPUT ../../bingo/sqlserver COMMAND msbuild)

=== debian/changelog ===
indigo (1.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Add myself to the uploaders.

 -- Andrius Merkys <merkys@debian.org>  Tue, 02 Dec 2025 09:42:56 -0500

indigo (1.2.3-6) unstable; urgency=medium

  * Team upload.
  * Build and package libbingo.
  * Avoid git usage which breaks git-buildpackage.

 -- Andrius Merkys <merkys@debian.org>  Thu, 27 Nov 2025 01:42:44 -0500

=== debian/control ===
Source: indigo
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Andrius Merkys <merkys@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               default-jdk,
               dh-python,
               javahelper,
               junit5,
               libcairo2-dev,
               libfreetype-dev,
               libinchi-dev,
               libjna-java,
               libpng-dev,
               libtinyxml-dev,
               python3,
Standards-Version: 4.4.1
Homepage: https://lifescience.opensource.epam.com/indigo/index.html
Vcs-Browser: https://salsa.debian.org/debichem-team/indigo
Vcs-Git: https://salsa.debian.org/debichem-team/indigo.git
Rules-Requires-Root: no

Package: indigo-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libindigo-java
Description: Organic Chemistry Toolkit Utilities
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.
 .
 This package contains the following utilities:
 .
  * indigo-depict: Molecule and reaction rendering utility
  * indigo-cano: Canonical SMILES generator
  * indigo-deco: R-Group deconvolution utility
  * chemdiff: Visual comparison of two SDF or SMILES files (needs the JAVA
    libraries)

Package: libbingo0d
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Organic Chemistry Toolkit (bingo shared library)
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.
 .
 This package includes the shared library for bingo.

Package: libbingo-dev
Architecture: any
Section: libdevel
Depends: libbingo0d (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Organic Chemistry Toolkit (bingo development files)
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry
  * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.
 .
 This package contains bingo static library and development files.

Package: libindigo0d
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Organic Chemistry Toolkit
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.

Package: libindigo-dev
Architecture: any
Section: libdevel
Depends: libindigo0d (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Organic Chemistry Toolkit (development files)
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry
  * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.
 .
 This package contains the static library and header files.

Package: python3-indigo
Architecture: all
Section: python
Depends: libindigo0d (>= ${source:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Organic Chemistry Toolkit (Python module)
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry
  * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.
 .
 This package contains the Python modules.

Package: libindigo-java
Architecture: all
Section: java
Depends: libindigo0d (>= ${source:Version}),
         ${java:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Organic Chemistry Toolkit (Java package)
 Indigo is a C++ based organic chemistry and cheminformatics software
 environment.  Features Include:
 .
  * Molecule and reaction rendering including SVG support
  * Automatic layout for SMILES-represented molecules and reactions
  * Canonical (isomeric) SMILES computation
  * Exact matching, substructure matching, SMARTS matching
  * Matching of tautomers and resonance structures
  * Molecule fingerprinting, molecule similarity computation
  * Fast enumeration of SSSR rings, subtrees, and edge sugraphs
  * Molecular weight, molecular formula computation
  * R-Group deconvolution and scaffold detection
  * Computation of the exact maximum common substructure for an
    arbitrary amount of input structures
  * Combinatorial chemistry
  * Plugin support in the API
 .
 File formats Indigo support include MDL Mol, SDF, RDF, CML, SMILES and
 SMARTS.
 .
 This package contains the Java packages.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export CPPFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS    := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS  := $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS   := $(shell dpkg-buildflags --get LDFLAGS)

export JAVA_HOME := /usr/lib/jvm/default-java
export CLASSPATH := /usr/share/java/jna.jar:/usr/share/java/junit-jupiter-api.jar:$(CURDIR)/indigo.jar:$(CURDIR)/indigo-renderer.jar:$(CURDIR)/common-controls.jar

%:
	dh $@ --with javahelper,python3

override_dh_auto_clean:
	find build_scripts/indigo-utils | grep -v CMakeLists | grep -v indigo-utils$$ | xargs rm -rf
	find . -type d -name "dist" | xargs rm -rf
	find . -name ".dep.inc" | xargs rm -f
	rm -f api/src/indigo_version.h
	rm -f $(CURDIR)/*.jar
	dh_auto_clean

override_dh_auto_configure:
	(cd build_scripts/indigo-utils && cmake -DCMAKE_BUILD_TYPE=None -DCMAKE_SKIP_RPATH=ON -DWITH_STATIC=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	 -DUSE_SYSTEM_ZLIB=YES -DUSE_SYSTEM_PNG=YES -DUSE_SYSTEM_CAIRO=YES -DUSE_SYSTEM_PIXMAN=YES \
	 -DCAIRO_LIBRARY_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH) \
	 -DPIXMAN_LIBRARY_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH) -DPIXMAN_INCLUDE_DIRS=/usr/include/pixman-1 -DLIBPIXMAN=libpixman-1.so \
	 -DTINYXML_LIBRARY_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH) .)
	(cd build_scripts/bingo && cmake -DCMAKE_BUILD_TYPE=None -DCMAKE_SKIP_RPATH=ON -DWITH_STATIC=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	 -DUSE_SYSTEM_ZLIB=YES -DUSE_SYSTEM_PNG=YES -DUSE_SYSTEM_CAIRO=YES -DUSE_SYSTEM_PIXMAN=YES \
	 -DCAIRO_LIBRARY_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH) \
	 -DPIXMAN_LIBRARY_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH) -DPIXMAN_INCLUDE_DIRS=/usr/include/pixman-1 -DLIBPIXMAN=libpixman-1.so \
	 -DTINYXML_LIBRARY_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH) .)

execute_before_dh_auto_build:
	$(MAKE) -C build_scripts/indigo-utils VERBOSE=1
	$(MAKE) -C build_scripts/bingo VERBOSE=1

override_dh_auto_install-arch:
	dh_installdirs -a
	install $(CURDIR)/utils/chemdiff/chemdiff.sh						\
		debian/indigo-utils/usr/bin/chemdiff
	dh_auto_install -a

override_dh_auto_install-indep:
	dh_installdirs -i
	mkdir -p debian/python3-indigo/usr/lib/`py3versions -d`/dist-packages
	install -m0644 $(CURDIR)/api/python/indigo.py $(CURDIR)/api/plugins/renderer/python/*.py	\
		debian/python3-indigo/usr/lib/`py3versions -d`/dist-packages
	dh_auto_install -i

override_dh_makeshlibs:
	dh_makeshlibs -V
